'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _promisify = require('./promisify');

var _promisify2 = _interopRequireDefault(_promisify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CachedDictionary = function () {
  function CachedDictionary(redis, delegate) {
    _classCallCheck(this, CachedDictionary);

    this.redis = (0, _promisify2.default)(redis);
    this.delegate = delegate;
  }

  _createClass(CachedDictionary, [{
    key: 'read',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(keys) {
        var _this = this;

        var values, missingIds, newValues, promises;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.redis.hmget(this.getName(), keys);

              case 2:
                values = _context.sent;
                missingIds = keys.map(function (key, idx) {
                  if (values[idx] === null) {
                    return key;
                  }
                  return '';
                }).filter(function (value) {
                  return value !== '';
                });
                newValues = [];

                if (!(missingIds.length > 0)) {
                  _context.next = 9;
                  break;
                }

                _context.next = 8;
                return this.delegate.read(missingIds);

              case 8:
                newValues = _context.sent;

              case 9:
                promises = values.map(function (value, idx) {
                  if (value === null) {
                    var newValue = newValues.shift();
                    values[idx] = newValue;
                    if (newValue) {
                      return _this.set(keys[idx], newValue);
                    }
                  } else if (values[idx] === CachedDictionary.MISSING_KEY) {
                    values[idx] = null;
                  }
                  return Promise.resolve();
                });
                _context.next = 12;
                return Promise.all(promises);

              case 12:
                return _context.abrupt('return', values);

              case 13:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function read(_x) {
        return _ref.apply(this, arguments);
      }

      return read;
    }()
  }, {
    key: 'set',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(key, value) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.delegate.set(key, value);

              case 2:
                _context2.next = 4;
                return this.redis.hset(this.getName(), key, value);

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function set(_x2, _x3) {
        return _ref2.apply(this, arguments);
      }

      return set;
    }()
  }, {
    key: 'remove',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(key) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.delegate.remove(key);

              case 2:
                _context3.next = 4;
                return this.redis.hset(this.getName(), key, CachedDictionary.MISSING_KEY);

              case 4:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function remove(_x4) {
        return _ref3.apply(this, arguments);
      }

      return remove;
    }()
  }, {
    key: 'getName',
    value: function getName() {
      return this.delegate.getName();
    }
  }]);

  return CachedDictionary;
}();

CachedDictionary.MISSING_KEY = '__MISSING__';
exports.default = CachedDictionary;