'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _promisify = require('./promisify');

var _promisify2 = _interopRequireDefault(_promisify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CachedEdge = function () {
  function CachedEdge(redis, delegate) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, CachedEdge);

    this.redis = (0, _promisify2.default)(redis);
    this.delegate = delegate;
    this.forward = options.reverse ? false : true;
  }

  _createClass(CachedEdge, [{
    key: '_watermark',
    value: function _watermark(leftId) {
      return leftId + '_' + this.delegate.getName() + '_watermark';
    }
  }, {
    key: '_get',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(key) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', this.redis.get(key));

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _get(_x2) {
        return _ref.apply(this, arguments);
      }

      return _get;
    }()
  }, {
    key: '_create',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(id, leftNodeId, rightNodeId, data) {
        var watermarkName, watermarkString, watermark, multi, name, counterName;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                watermarkName = this._watermark(leftNodeId);

                this.redis.__base.watch(watermarkName);

                _context2.prev = 2;
                _context2.next = 5;
                return this.redis.get(watermarkName);

              case 5:
                watermarkString = _context2.sent;
                watermark = parseInt(watermarkString, 10);
                multi = (0, _promisify2.default)(this.redis.__base.multi());
                name = this._name(leftNodeId);
                counterName = name + '_count';


                multi.__base.incr(counterName);

                if (this.forward) {
                  if (id < watermark) {
                    multi.__base.zadd(this._name(leftNodeId), id, JSON.stringify({ id: id, nodeId: rightNodeId, data: data }));
                  }
                } else {
                  if (id > watermark) {
                    multi.__base.zadd(this._name(leftNodeId), id, JSON.stringify({ id: id, nodeId: rightNodeId, data: data }));
                  }
                }
                _context2.next = 14;
                return multi.exec();

              case 14:
                _context2.next = 20;
                break;

              case 16:
                _context2.prev = 16;
                _context2.t0 = _context2['catch'](2);

                this.redis.__base.unwatch();
                throw _context2.t0;

              case 20:
                return _context2.abrupt('return', id);

              case 21:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[2, 16]]);
      }));

      function _create(_x3, _x4, _x5, _x6) {
        return _ref2.apply(this, arguments);
      }

      return _create;
    }()
  }, {
    key: 'create',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(leftNodeId, rightNodeId, data) {
        var id, tries, lastError;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.delegate.create(leftNodeId, rightNodeId, data);

              case 2:
                id = _context3.sent;
                tries = 0;
                lastError = void 0;

              case 5:
                if (!(tries < 4)) {
                  _context3.next = 16;
                  break;
                }

                _context3.prev = 6;
                return _context3.abrupt('return', this._create(id, leftNodeId, rightNodeId, data));

              case 10:
                _context3.prev = 10;
                _context3.t0 = _context3['catch'](6);

                lastError = _context3.t0;
                tries = tries + 1;

              case 14:
                _context3.next = 5;
                break;

              case 16:
                throw new Error('Could not update cache.  leftNodeId: ' + leftNodeId + ' rightNodeId: ' + rightNodeId + ' data: ' + data + ' ' + lastError);

              case 17:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[6, 10]]);
      }));

      function create(_x7, _x8, _x9) {
        return _ref3.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: '_read',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(leftId, _ref4) {
        var after = _ref4.after,
            firstOrUndefined = _ref4.first;
        var first, edgeName, min, max, args, data;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                first = firstOrUndefined || CachedEdge.MAX_BATCH;
                edgeName = this._name(leftId);
                min = void 0;
                max = void 0;

                if (after != null) {
                  min = '(' + after;
                } else {
                  min = this.forward ? -Infinity : +Infinity;
                }

                max = this.forward ? +Infinity : -Infinity;

                args = [edgeName, min, max, 'LIMIT', 0, Math.min(first, CachedEdge.MAX_BATCH)];
                data = void 0;

                if (!this.forward) {
                  _context4.next = 14;
                  break;
                }

                _context4.next = 11;
                return this.redis.zrangebyscore(args);

              case 11:
                data = _context4.sent;
                _context4.next = 17;
                break;

              case 14:
                _context4.next = 16;
                return this.redis.zrevrangebyscore(args);

              case 16:
                data = _context4.sent;

              case 17:
                return _context4.abrupt('return', data.map(function (x) {
                  return JSON.parse(x);
                }));

              case 18:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function _read(_x10, _x11) {
        return _ref5.apply(this, arguments);
      }

      return _read;
    }()
  }, {
    key: '_getRankOfEdgeItem',
    value: function _getRankOfEdgeItem(name, id) {
      if (this.forward) {
        return this.redis.zcount(name, -Infinity, '(' + id);
      } else {
        return this.redis.zcount(name, +Infinity, '(' + id);
      }
    }
  }, {
    key: '_name',
    value: function _name(leftId) {
      return this.delegate.getName() + '_' + leftId;
    }
  }, {
    key: '_getCountOfEdge',
    value: function _getCountOfEdge(leftId) {
      return this.redis.zcard(this._name(leftId));
    }
  }, {
    key: '_updateEdgeCache',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(leftId, first, hasNextPage, edges) {
        var _this = this;

        var watermarkName, watermarkString, multi, prefix, watermark, edgesToAdd, newHasNextPage;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                watermarkName = this._watermark(leftId);

                this.redis.__base.watch(watermarkName);
                _context5.next = 4;
                return this.redis.get(watermarkName);

              case 4:
                watermarkString = _context5.sent;
                multi = (0, _promisify2.default)(this.redis.__base.multi());
                prefix = [this._name(leftId)];
                watermark = parseInt(watermarkString, 10);
                edgesToAdd = void 0;


                if (!isNaN(watermark)) {
                  edgesToAdd = edges.filter(function (edge) {
                    if (_this.forward) {
                      return edge.id > watermark;
                    } else {
                      return edge.id < watermark;
                    }
                  });
                } else {
                  edgesToAdd = edges;
                }

                edgesToAdd.forEach(function (x) {
                  prefix.push(x.id);
                  prefix.push(JSON.stringify(x));
                });

                if (edgesToAdd.length > 0) {
                  multi.__base.set(this._watermark(leftId), edgesToAdd[edgesToAdd.length - 1].id);
                  multi.__base.zadd(prefix);
                }

                _context5.next = 14;
                return multi.exec();

              case 14:
                newHasNextPage = first < edges.length;
                return _context5.abrupt('return', { hasNextPage: newHasNextPage || hasNextPage, edges: edges.slice(0, first) });

              case 16:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _updateEdgeCache(_x12, _x13, _x14, _x15) {
        return _ref6.apply(this, arguments);
      }

      return _updateEdgeCache;
    }()
  }, {
    key: 'getFirstAfter',
    value: function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(leftId) {
        var _ref8 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            after = _ref8.after,
            firstOrUndefined = _ref8.first;

        var edgeName, first, rank, _ref9, _hasNextPage, _edges, count, _edges2, _ref10, hasNextPage, edges, tries, lastError, page;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                edgeName = this._name(leftId);
                first = firstOrUndefined || CachedEdge.MAX_BATCH;
                rank = void 0;

                if (!(after != null)) {
                  _context6.next = 16;
                  break;
                }

                _context6.next = 6;
                return this._getRankOfEdgeItem(edgeName, after);

              case 6:
                rank = _context6.sent;

                if (!(rank == null)) {
                  _context6.next = 14;
                  break;
                }

                _context6.next = 10;
                return this.delegate.getFirstAfter(leftId, { after: after, first: first });

              case 10:
                _ref9 = _context6.sent;
                _hasNextPage = _ref9.hasNextPage;
                _edges = _ref9.edges;
                return _context6.abrupt('return', {
                  hasNextPage: _hasNextPage,
                  edges: _edges
                });

              case 14:
                _context6.next = 17;
                break;

              case 16:
                rank = 0;

              case 17:
                _context6.next = 19;
                return this._getCountOfEdge(leftId);

              case 19:
                count = _context6.sent;

                if (!(rank + 1 + first <= count)) {
                  _context6.next = 25;
                  break;
                }

                _context6.next = 23;
                return this._read(leftId, { after: after, first: first });

              case 23:
                _edges2 = _context6.sent;
                return _context6.abrupt('return', { hasNextPage: rank + 1 + first < count, edges: _edges2 });

              case 25:
                _context6.next = 27;
                return this.delegate.getFirstAfter(leftId, { after: after, first: CachedEdge.MAX_BATCH });

              case 27:
                _ref10 = _context6.sent;
                hasNextPage = _ref10.hasNextPage;
                edges = _ref10.edges;
                tries = 0;
                lastError = void 0;

              case 32:
                if (!(tries < 4)) {
                  _context6.next = 46;
                  break;
                }

                _context6.prev = 33;
                _context6.next = 36;
                return this._updateEdgeCache(leftId, first, hasNextPage, edges);

              case 36:
                page = _context6.sent;
                return _context6.abrupt('return', page);

              case 40:
                _context6.prev = 40;
                _context6.t0 = _context6['catch'](33);

                lastError = _context6.t0;
                tries = tries + 1;

              case 44:
                _context6.next = 32;
                break;

              case 46:
                throw new Error('Could not update edge cache. leftId: ' + leftId + ' first: ' + first + ' hasNextPage: ' + hasNextPage + ' edges: ' + edges + ' ' + lastError);

              case 47:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this, [[33, 40]]);
      }));

      function getFirstAfter(_x17) {
        return _ref7.apply(this, arguments);
      }

      return getFirstAfter;
    }()
  }, {
    key: 'delete',
    value: function () {
      var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(leftId, id) {
        var name, counterName;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this.delegate.delete(leftId, id);

              case 2:
                _context7.next = 4;
                return this.redis.zremrangebyscore(this._name(leftId), id, id);

              case 4:
                name = this._name(leftId);
                counterName = name + '_count';


                this.redis.__base.decr(counterName);

              case 7:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function _delete(_x18, _x19) {
        return _ref11.apply(this, arguments);
      }

      return _delete;
    }()
  }, {
    key: '_updateCountRec',
    value: function () {
      var _ref12 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(leftId) {
        var name, counterName, count, multi, newCount, result;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                name = this._name(leftId);
                counterName = name + '_count';


                this.redis.watch(counterName);
                _context8.next = 5;
                return this.redis.get(counterName);

              case 5:
                count = _context8.sent;

                if (!count) {
                  _context8.next = 9;
                  break;
                }

                this.redis.__base.unwatch();
                return _context8.abrupt('return', count);

              case 9:
                multi = (0, _promisify2.default)(this.redis.__base.multi());
                _context8.next = 12;
                return this.delegate.getCount(leftId);

              case 12:
                newCount = _context8.sent;


                multi.__base.set(counterName, newCount.toString());

                _context8.next = 16;
                return multi.exec();

              case 16:
                result = _context8.sent;

                if (!(result === null)) {
                  _context8.next = 19;
                  break;
                }

                throw new Error('unable to update count');

              case 19:
                return _context8.abrupt('return', newCount);

              case 20:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function _updateCountRec(_x20) {
        return _ref12.apply(this, arguments);
      }

      return _updateCountRec;
    }()
  }, {
    key: '_updateCount',
    value: function () {
      var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(leftId) {
        var tries, newCount;
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                tries = 0;

              case 1:
                if (!(tries < 4)) {
                  _context9.next = 14;
                  break;
                }

                _context9.prev = 2;
                _context9.next = 5;
                return this._updateCountRec(leftId);

              case 5:
                newCount = _context9.sent;
                return _context9.abrupt('return', newCount);

              case 9:
                _context9.prev = 9;
                _context9.t0 = _context9['catch'](2);

                tries = tries + 1;

              case 12:
                _context9.next = 1;
                break;

              case 14:
                throw new Error('Could not update count');

              case 15:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this, [[2, 9]]);
      }));

      function _updateCount(_x21) {
        return _ref13.apply(this, arguments);
      }

      return _updateCount;
    }()
  }, {
    key: 'getCount',
    value: function () {
      var _ref14 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(leftId) {
        var name, count;
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                name = this._name(leftId);
                _context10.next = 3;
                return this.redis.get(name + '_count');

              case 3:
                count = _context10.sent;

                if (!(count == null)) {
                  _context10.next = 6;
                  break;
                }

                return _context10.abrupt('return', this._updateCount(leftId));

              case 6:
                return _context10.abrupt('return', parseInt(count));

              case 7:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function getCount(_x22) {
        return _ref14.apply(this, arguments);
      }

      return getCount;
    }()
  }, {
    key: 'getName',
    value: function getName() {
      return this.delegate.getName();
    }
  }, {
    key: '_update',
    value: function () {
      var _ref15 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(leftId, id, data) {
        var watermarkName, edgeName, watermarkString, watermark, multi, _ref16, _ref17, edgeJson, edge, result;

        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                watermarkName = this._watermark(leftId);
                edgeName = this._name(leftId);

                this.redis.__base.watch(edgeName, watermarkName);
                _context11.prev = 3;
                _context11.next = 6;
                return this.redis.get(watermarkName);

              case 6:
                watermarkString = _context11.sent;
                watermark = parseInt(watermarkString, 10);

                if (!isNaN(watermark)) {
                  _context11.next = 11;
                  break;
                }

                this.redis.__base.unwatch();
                return _context11.abrupt('return');

              case 11:
                if (!this.forward) {
                  _context11.next = 17;
                  break;
                }

                if (!(id > watermark)) {
                  _context11.next = 15;
                  break;
                }

                this.redis.__base.unwatch();
                return _context11.abrupt('return');

              case 15:
                _context11.next = 20;
                break;

              case 17:
                if (!(id < watermark)) {
                  _context11.next = 20;
                  break;
                }

                this.redis.__base.unwatch();
                return _context11.abrupt('return');

              case 20:
                multi = (0, _promisify2.default)(this.redis.__base.multi());
                _context11.next = 23;
                return this.redis.zrangebyscore(edgeName, id, id);

              case 23:
                _ref16 = _context11.sent;
                _ref17 = _slicedToArray(_ref16, 1);
                edgeJson = _ref17[0];

                multi.__base.zremrangebyscore(edgeName, id, id);
                edge = JSON.parse(edgeJson);

                edge.data = data;
                multi.__base.zadd(edgeName, id, JSON.stringify(edge));
                _context11.next = 32;
                return multi.exec();

              case 32:
                result = _context11.sent;

                if (!(result === null)) {
                  _context11.next = 35;
                  break;
                }

                throw new Error('Failed to update edge cache.');

              case 35:
                _context11.next = 41;
                break;

              case 37:
                _context11.prev = 37;
                _context11.t0 = _context11['catch'](3);

                this.redis.__base.unwatch();
                throw _context11.t0;

              case 41:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this, [[3, 37]]);
      }));

      function _update(_x23, _x24, _x25) {
        return _ref15.apply(this, arguments);
      }

      return _update;
    }()
  }, {
    key: 'update',
    value: function () {
      var _ref18 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(leftId, id, data) {
        var tries;
        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.delegate.update(leftId, id, data);

              case 2:
                tries = 0;

              case 3:
                if (!(tries < 4)) {
                  _context12.next = 15;
                  break;
                }

                _context12.prev = 4;
                _context12.next = 7;
                return this._update(leftId, id, data);

              case 7:
                return _context12.abrupt('return');

              case 10:
                _context12.prev = 10;
                _context12.t0 = _context12['catch'](4);

                tries = tries + 1;

              case 13:
                _context12.next = 3;
                break;

              case 15:
                throw new Error('Failed to update edge.');

              case 16:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this, [[4, 10]]);
      }));

      function update(_x26, _x27, _x28) {
        return _ref18.apply(this, arguments);
      }

      return update;
    }()
  }]);

  return CachedEdge;
}();

CachedEdge.MAX_BATCH = 50;
exports.default = CachedEdge;