'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _promisify = require('./promisify');

var _promisify2 = _interopRequireDefault(_promisify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CachedNode = function () {
  function CachedNode(redis, delegate) {
    _classCallCheck(this, CachedNode);

    this.redis = (0, _promisify2.default)(redis);
    this.delegate = delegate;
  }

  _createClass(CachedNode, [{
    key: '_id',
    value: function _id(id) {
      return this.delegate.getName() + '_' + id;
    }
  }, {
    key: '_create',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(data) {
        var _this = this;

        var params;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                params = [];

                data.forEach(function (datum) {
                  params.push(_this._id(datum.id));
                  params.push(JSON.stringify(datum));
                });
                return _context.abrupt('return', this.redis.mset(params));

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _create(_x) {
        return _ref.apply(this, arguments);
      }

      return _create;
    }()
  }, {
    key: 'create',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(data) {
        var nodes;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.delegate.create(data);

              case 2:
                nodes = _context2.sent;
                _context2.next = 5;
                return this._create(nodes);

              case 5:
                return _context2.abrupt('return', nodes);

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function create(_x2) {
        return _ref2.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: 'read',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(ids) {
        var _this2 = this;

        var nodeIds, nodes, idToIndex, missingIds, delegateNodes, promises;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(!ids || ids.length === 0)) {
                  _context3.next = 2;
                  break;
                }

                return _context3.abrupt('return', []);

              case 2:
                nodeIds = ids.map(function (id) {
                  return _this2._id(id);
                });
                _context3.next = 5;
                return this.redis.mget(nodeIds);

              case 5:
                nodes = _context3.sent;
                idToIndex = {};


                ids.forEach(function (id, idx) {
                  idToIndex[id] = idx;
                });
                missingIds = [];

                nodes.forEach(function (node, idx) {
                  nodes[idx] = undefined;
                  if (node === null) {
                    missingIds.push(ids[idx]);
                  } else if (node !== 'MISSING') {
                    try {
                      nodes[idx] = JSON.parse(node);
                    } catch (_) {
                      nodes[idx] = 'CORRUPT';
                    }
                  }
                });

                if (!(missingIds.length > 0)) {
                  _context3.next = 17;
                  break;
                }

                _context3.next = 13;
                return this.delegate.read(missingIds);

              case 13:
                delegateNodes = _context3.sent;
                promises = delegateNodes.map(function (delegateNode) {
                  if (delegateNode) {
                    nodes[idToIndex[delegateNode.id]] = delegateNode;
                    return _this2._create([delegateNode]);
                  }
                  return Promise.resolve();
                });
                _context3.next = 17;
                return Promise.all(promises);

              case 17:
                return _context3.abrupt('return', nodes);

              case 18:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function read(_x3) {
        return _ref3.apply(this, arguments);
      }

      return read;
    }()
  }, {
    key: 'evict',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(ids) {
        var _this3 = this;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', this.redis.del(ids.map(function (id) {
                  return _this3._id(id);
                })));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function evict(_x4) {
        return _ref4.apply(this, arguments);
      }

      return evict;
    }()
  }, {
    key: 'update',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(node) {
        var nodeId, cachedNode, multi, newNode, success, result;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                nodeId = this._id(node.id);

                this.redis.__base.watch(nodeId);
                _context5.next = 4;
                return this.redis.get(nodeId);

              case 4:
                cachedNode = _context5.sent;

                if (!(cachedNode === 'MISSING')) {
                  _context5.next = 8;
                  break;
                }

                this.redis.__base.unwatch();
                throw new Error('Id ' + node.id + ' does not exist');

              case 8:
                if (!cachedNode) {
                  _context5.next = 12;
                  break;
                }

                if (!(cachedNode.updateId && node.updateId && cachedNode.updateId !== node.updateId)) {
                  _context5.next = 12;
                  break;
                }

                this.redis.__base.unwatch();
                return _context5.abrupt('return', false);

              case 12:
                multi = (0, _promisify2.default)(this.redis.__base.multi());
                newNode = Object.assign({}, node);


                if (newNode.updateId) {
                  newNode.updateId = newNode.updateId + 1;
                }

                multi.__base.set(nodeId, JSON.stringify(newNode));

                _context5.next = 18;
                return this.delegate.update(node);

              case 18:
                success = _context5.sent;

                if (!success) {
                  _context5.next = 27;
                  break;
                }

                _context5.next = 22;
                return multi.exec();

              case 22:
                result = _context5.sent;

                if (!(result === null)) {
                  _context5.next = 25;
                  break;
                }

                throw new Error('Failed to update node');

              case 25:
                _context5.next = 28;
                break;

              case 27:
                multi.__base.discard();

              case 28:
                return _context5.abrupt('return', success);

              case 29:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function update(_x5) {
        return _ref5.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: 'delete',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(id) {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.delegate.delete(id);

              case 2:
                _context6.next = 4;
                return this.redis.set(this._id(id), 'MISSING');

              case 4:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _delete(_x6) {
        return _ref6.apply(this, arguments);
      }

      return _delete;
    }()
  }, {
    key: 'getName',
    value: function getName() {
      return this.delegate.getName();
    }
  }]);

  return CachedNode;
}();

exports.default = CachedNode;