"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MemoryEdge = function () {
  function MemoryEdge(name) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, MemoryEdge);

    this.name = name;
    this.edges = {};
    this.forward = options.forward !== false;
    this.id = 0;
  }

  _createClass(MemoryEdge, [{
    key: "getName",
    value: function getName() {
      return this.name;
    }
  }, {
    key: "getCount",
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(leftId) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", this.edges[leftId] ? this.edges[leftId].length : 0);

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getCount(_x2) {
        return _ref.apply(this, arguments);
      }

      return getCount;
    }()
  }, {
    key: "create",
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(leftNodeId, rightNodeId, data) {
        var id;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.edges[leftNodeId] = this.edges[leftNodeId] || [];

                id = this.id;

                this.id += 1;

                if (this.forward) {
                  this.edges[leftNodeId].push({ id: id, nodeId: rightNodeId, data: data });
                } else {
                  this.edges[leftNodeId].unshift({ id: id, nodeId: rightNodeId, data: data });
                }

                return _context2.abrupt("return", id);

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function create(_x3, _x4, _x5) {
        return _ref2.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: "update",
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(leftId, id, data) {
        var offset;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                offset = this.edges[leftId].findIndex(function (edge) {
                  return edge.id === id;
                });

                this.edges[leftId][offset].data = data;

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function update(_x6, _x7, _x8) {
        return _ref3.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "getFirstAfter",
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(leftId, _ref4) {
        var after = _ref4.after,
            first = _ref4.first;
        var offset, edges, hasNextPage;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!(this.edges[leftId] == null)) {
                  _context4.next = 2;
                  break;
                }

                return _context4.abrupt("return", {
                  hasNextPage: false,
                  edges: []
                });

              case 2:
                offset = after != null ? this.edges[leftId].findIndex(function (edge) {
                  return edge.id === after;
                }) + 1 : 0;
                edges = this.edges[leftId].slice(offset, offset + first);
                hasNextPage = first + offset < this.edges[leftId].length;
                return _context4.abrupt("return", {
                  hasNextPage: hasNextPage,
                  edges: edges
                });

              case 6:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getFirstAfter(_x9, _x10) {
        return _ref5.apply(this, arguments);
      }

      return getFirstAfter;
    }()
  }, {
    key: "delete",
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(leftId, id) {
        var index;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                index = this.edges[leftId].findIndex(function (edge) {
                  return edge.id === id;
                });

                this.edges[leftId].splice(index, 1);

              case 2:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _delete(_x11, _x12) {
        return _ref6.apply(this, arguments);
      }

      return _delete;
    }()
  }]);

  return MemoryEdge;
}();

exports.default = MemoryEdge;