'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = promisify;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function promisify(parent, prop) {
  return new Proxy(prop ? parent[prop] : parent, {
    get: function get(target, property, receiver) {
      if (property === '__base') {
        return target;
      }
      if (typeof target[property] === 'function') {
        return promisify(target, property);
      } else {
        return target[property];
      }
    },
    apply: function apply(target, thisArg, args) {
      return new Promise(function (resolve, reject) {
        if (typeof target === 'function') {
          Reflect.apply(target, parent, [].concat(_toConsumableArray(args), [function (err) {
            for (var _len = arguments.length, more = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              more[_key - 1] = arguments[_key];
            }

            if (err) {
              reject(err);
              return;
            }
            resolve.apply(undefined, more);
          }]));
        } else {
          reject(new Error('not a function'));
        }
      });
    }
  });
}